package com.tomwheeler.stocktrader.api.events;

import java.util.EventListener;

/**
 * <p>
 * This interface allows the implementer to be notified upon changes to a 
 * StockAccount.
 * </p> 
 * 
 * @author Tom Wheeler
 */
public interface StockAccountListener extends EventListener {
    
    /** This method is called whenever stocks have been purchased for the StockAccount */
    public void stockPurchased(StockAccountChangeEvent event);
    
    /** This method is called whenever stocks have been sold from the StockAccount */
    public void stocksSold(StockAccountChangeEvent event);

}
