package com.tomwheeler.stocktrader.api.events;

/**
 * <p>
 * This class stores data associated with changes in a stock's price. 
 * </p> 
 * 
 * @author Tom Wheeler
 */
public class StockPriceChangeEvent extends AbstractChangeEvent {

    private String symbol;

    /** creates a new NewsStoryEvent with the specified description and symbol */
    public StockPriceChangeEvent(String changeDescription, String symbol) {
        super(changeDescription);
        this.symbol = symbol;
    }

    /** 
     * <p>
     * This method returns the symbol for the stock price whose change caused this event.
     * </p>
     * 
     * @return the stock symbol  
     */ 
    public String getSymbol() {
        return symbol;
    }
}
